USE COWS
GO

CREATE TABLE [dbo].[LK_EVENT_RULE](
	[EVENT_RULE_ID] [int] NOT NULL,
	[USR_PRF_ID] [smallint] NOT NULL,
	[EVENT_TYPE_ID] [smallint] NOT NULL,
	[ORDR_TYPE_CD] [char](3) NULL,-- Only Fed Events
	[STRT_EVENT_STUS_ID] [tinyint] NOT NULL,
	[END_EVENT_STUS_ID] [tinyint] NOT NULL,
	[WRKFLW_STUS_ID] [tinyint] NULL,
	[CAL_CD] [tinyint] NULL, --NULL:both add/del=0;0:add=0/del=1;1:add=1/del=0;2:add=1/del=1
	[ACTN_ID] [tinyint] NOT NULL, --Merge multiple actn_ids into one; 20 is needed for all rules because there might be data update
	[FAIL_REAS_ID] [smallint] NULL, --Only MDS
	[STAGN_CD] [BIT] NULL, --Only MDS
	[FED_MSG_ID] [tinyint] NULL, --Only Fed
	[REC_STUS_ID] [tinyint] NOT NULL,
	[MODFD_DT] [smalldatetime] NULL,
	[CREAT_DT] [smalldatetime] NOT NULL,
 CONSTRAINT [PK_LK_EVENT_RULE] PRIMARY KEY CLUSTERED 
(
	[EVENT_RULE_ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO

CREATE NONCLUSTERED INDEX [IX01_LK_EVENT_RULE] ON [dbo].[LK_EVENT_RULE]
(
	[EVENT_TYPE_ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

ALTER TABLE [dbo].[LK_EVENT_RULE] ADD  CONSTRAINT [DF_LK_EVENT_RULE_1]  DEFAULT ((1)) FOR [REC_STUS_ID]
GO

ALTER TABLE [dbo].[LK_EVENT_RULE] ADD  CONSTRAINT [DF_LK_EVENT_RULE_getdate]  DEFAULT (getdate()) FOR [CREAT_DT]
GO

ALTER TABLE [dbo].[LK_EVENT_RULE]  ADD  CONSTRAINT [FK01_LK_EVENT_RULE] FOREIGN KEY([REC_STUS_ID])
REFERENCES [dbo].[LK_REC_STUS] ([REC_STUS_ID])
GO

ALTER TABLE [dbo].[LK_EVENT_RULE]  ADD  CONSTRAINT [FK02_LK_EVENT_RULE] FOREIGN KEY([USR_PRF_ID])
REFERENCES [dbo].[LK_USR_PRF] ([USR_PRF_ID])
GO

ALTER TABLE [dbo].[LK_EVENT_RULE]  ADD  CONSTRAINT [FK03_LK_EVENT_RULE] FOREIGN KEY([EVENT_TYPE_ID])
REFERENCES [dbo].[LK_EVENT_TYPE] ([EVENT_TYPE_ID])
GO

ALTER TABLE [dbo].[LK_EVENT_RULE]  ADD  CONSTRAINT [FK04_LK_EVENT_RULE] FOREIGN KEY([STRT_EVENT_STUS_ID])
REFERENCES [dbo].[LK_EVENT_STUS] ([EVENT_STUS_ID])
GO

ALTER TABLE [dbo].[LK_EVENT_RULE]  ADD  CONSTRAINT [FK05_LK_EVENT_RULE] FOREIGN KEY([END_EVENT_STUS_ID])
REFERENCES [dbo].[LK_EVENT_STUS] ([EVENT_STUS_ID])
GO

ALTER TABLE [dbo].[LK_EVENT_RULE]  ADD  CONSTRAINT [FK06_LK_EVENT_RULE] FOREIGN KEY([WRKFLW_STUS_ID])
REFERENCES [dbo].[LK_WRKFLW_STUS] ([WRKFLW_STUS_ID])
GO

ALTER TABLE [dbo].[LK_EVENT_RULE]  ADD  CONSTRAINT [FK07_LK_EVENT_RULE] FOREIGN KEY([ORDR_TYPE_CD])
REFERENCES [dbo].[LK_FEDLINE_ORDR_TYPE] ([ORDR_TYPE_CD])
GO

ALTER TABLE [dbo].[LK_EVENT_RULE]  ADD  CONSTRAINT [FK08_LK_EVENT_RULE] FOREIGN KEY([ACTN_ID])
REFERENCES [dbo].[LK_ACTN] ([ACTN_ID])
GO

ALTER TABLE [dbo].[LK_EVENT_RULE]  ADD  CONSTRAINT [FK09_LK_EVENT_RULE] FOREIGN KEY([FAIL_REAS_ID])
REFERENCES [dbo].[LK_FAIL_REAS] ([FAIL_REAS_ID])
GO

ALTER TABLE [dbo].[LK_EVENT_RULE]  ADD  CONSTRAINT [FK10_LK_EVENT_RULE] FOREIGN KEY([FED_MSG_ID])
REFERENCES [dbo].[LK_FED_MSG] ([FED_MSG_ID])
GO